/'--------------------------------------------------------------------
                      Asteroids (c) ATARI INC              
                  Remake by Vincent DeCampo 2009      

   This program is free software: you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

--------------------------------------------------------------------'/
#Define MAX_PARTICLES 500

Type _Particle
   alive    As Integer
   clr      As UInteger
   x        As Double
   y        As Double
   dx       As Double
   dy       As Double
   ttl      As Double = 0
End Type

Function SpawnParticles (Part As _Particle Ptr, syncx As Double, syncy As Double, _
                         Count As Integer, ttl As Double, speed As Double) As Integer   
Dim ang As Double

   For p As Integer = 0 To MAX_PARTICLES-1
      With Part[p]
         If .alive = 0 Then
            
            .alive   = 1
            .ttl     = Timer + ttl
            .clr     = &hFFFFFF
            .x       = syncx
            .y       = syncy
            ang      = Rnd*PI2
            .dx      = Cos(ang)
            .dy      = Sin(ang)
            .x      +=.dx*speed
            .y      +=.dy*speed
            Count   -= 1
            
            If Count = 0 Then Return 1
            
         EndIf
      End With
   Next
   
   Return 0
   
End Function

Sub RenderParticles (Part As _Particle Ptr)
Dim As UInteger Clr,Rad
     
   For p As Integer = 0 To MAX_PARTICLES-1
      With Part[p]         
         If .alive Then
            If .ttl > Timer Then               
               Pset(.x,.y),.clr   
               .x += .dx
               .y += .dy
            Else
               .alive = 0
            End If
         EndIf         
      End With
   Next 
   
End Sub
